
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Telemetry_eventsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const telemetry_events = await db.telemetry_events.create(
            {
                id: data.id || undefined,
        
        observed_at: data.observed_at
        ||
        null
            ,
            
        event_type: data.event_type
        ||
        null
            ,
            
        severity: data.severity
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
        raw_payload: data.raw_payload
        ||
        null
            ,
            
        hash: data.hash
        ||
        null
            ,
            
        flagged: data.flagged
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await telemetry_events.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await telemetry_events.setData_source( data.data_source || null, {
            transaction,
        });
        
        await telemetry_events.setAsset( data.asset || null, {
            transaction,
        });
        

        

        

        return telemetry_events;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const telemetry_eventsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                observed_at: item.observed_at
            ||
            null
            ,
            
                event_type: item.event_type
            ||
            null
            ,
            
                severity: item.severity
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
                raw_payload: item.raw_payload
            ||
            null
            ,
            
                hash: item.hash
            ||
            null
            ,
            
                flagged: item.flagged
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const telemetry_events = await db.telemetry_events.bulkCreate(telemetry_eventsData, { transaction });

        // For each item created, replace relation files
        

        return telemetry_events;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const telemetry_events = await db.telemetry_events.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.observed_at !== undefined) updatePayload.observed_at = data.observed_at;
        
        
        if (data.event_type !== undefined) updatePayload.event_type = data.event_type;
        
        
        if (data.severity !== undefined) updatePayload.severity = data.severity;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        if (data.raw_payload !== undefined) updatePayload.raw_payload = data.raw_payload;
        
        
        if (data.hash !== undefined) updatePayload.hash = data.hash;
        
        
        if (data.flagged !== undefined) updatePayload.flagged = data.flagged;
        
        
        updatePayload.updatedById = currentUser.id;

        await telemetry_events.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await telemetry_events.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.data_source !== undefined) {
            await telemetry_events.setData_source(
              
              data.data_source,
              
              { transaction }
            );
        }
        
        if (data.asset !== undefined) {
            await telemetry_events.setAsset(
              
              data.asset,
              
              { transaction }
            );
        }
        

        
        

        

        return telemetry_events;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const telemetry_events = await db.telemetry_events.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of telemetry_events) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of telemetry_events) {
                await record.destroy({transaction});
            }
        });


        return telemetry_events;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const telemetry_events = await db.telemetry_events.findByPk(id, options);

        await telemetry_events.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await telemetry_events.destroy({
            transaction
        });

        return telemetry_events;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const telemetry_events = await db.telemetry_events.findOne(
            { where },
            { transaction },
        );

        if (!telemetry_events) {
            return telemetry_events;
        }

        const output = telemetry_events.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.detections_event = await telemetry_events.getDetections_event({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await telemetry_events.getOrganization({
            transaction
        });
        
        
        output.data_source = await telemetry_events.getData_source({
            transaction
        });
        
        
        output.asset = await telemetry_events.getAsset({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.data_sources,
        as: 'data_source',
        
        where: filter.data_source ? {
          [Op.or]: [
            { id: { [Op.in]: filter.data_source.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.data_source.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.assets,
        as: 'asset',
        
        where: filter.asset ? {
          [Op.or]: [
            { id: { [Op.in]: filter.asset.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.asset.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'telemetry_events',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            
            if (filter.raw_payload) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'telemetry_events',
                        'raw_payload',
                        filter.raw_payload,
                    ),
                };
            }
            
            if (filter.hash) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'telemetry_events',
                        'hash',
                        filter.hash,
                    ),
                };
            }
            

            
            

            
            if (filter.observed_atRange) {
                const [start, end] = filter.observed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    observed_at: {
                    ...where.observed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    observed_at: {
                    ...where.observed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.event_type) {
                where = {
                    ...where,
                event_type: filter.event_type,
            };
            }
            
            if (filter.severity) {
                where = {
                    ...where,
                severity: filter.severity,
            };
            }
            
            if (filter.flagged) {
                where = {
                    ...where,
                flagged: filter.flagged,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.telemetry_events.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'telemetry_events',
                        'summary',
                        query,
                    ),
                ],
            };
        }

        const records = await db.telemetry_events.findAll({
            attributes: [ 'id', 'summary' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['summary', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.summary,
        }));
    }

    
};

